<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}


function SUNUCUCOM_Config()
{
    return [

        'name' => 'SUNUCUCOM MANAGER',

        'description' => 'Sunucu.com tarafından sağlanan server manager modülüdür.',

        'version' => '1.2',

        "premium" => true,

        "language" => "english",

        'author' => '<a href="https://www.sunucu.com/" target="_blank"><img src="../modules/addons/SUNUCUCOM/templates/assets/img/icon.png" width="70"></a>',
        
        'fields' => [

            'EmailAddress' => [
                'FriendlyName' => 'E-Mail',
                'Type' => 'text',
                'Size' => '25',
            ],

            'EmailPassword' => [
                'FriendlyName' => 'Password',
                'Type' => 'password',
                'Size' => '25',
            ],
        ]
    ];
}

function SUNUCUCOM_Output($vars) {

$_lang = $vars['_lang'];


function ClientDetails($email, $password) {

	$data = [ 'params' => [ 'email' => $email, 'password'=> $password ]];
	
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, 'https://sunucu.com/api/v1/account/login/');
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
	curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 60);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-type: application/json', 'accept: application/json']);
	$response = curl_exec($ch);
	
	return $response;
}

$AccountToken = json_decode(ClientDetails($vars['EmailAddress'], $vars['EmailPassword']), true);

function ServerList($email, $password, $token) {

	$data = ['token' => $token,'pagination' => ['limit' => 9999]];

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, 'https://sunucu.com/api/v1/server/list');
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYSTATUS, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
	curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 60);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-type: application/json', 'accept: application/json']);
	$response = curl_exec($ch);
	
	return $response;

}

$serversList = json_decode(ServerList($vars['EmailAddress'], $vars['EmailPassword'], $AccountToken['data']['token']));

$response = '<div class="contentarea" id="contentarea">
    	<div style="float:left;width:100%;">

        <h1>SUNUCUCOM MANAGER</h1>
        <link rel="stylesheet" href="../modules/addons/SUNUCUCOM/templates/assets/css/layers-ui.css">

        <div id="layers">
            <div class="app">
                <div class="app-header app-header--responsive navbar">
                    <a class="navbar__brand brand brand--product" href="#">
                        <div class="brand__logo server-manager-whmcs i-c-5x">
                            <img class="i-c-3x" src="../modules/addons/SUNUCUCOM/templates/assets/img/server.svg" alt="SUNUCUCOM MANAGER">
                        </div>
                        <div class="brand__text">
                            SUNUCUCOM MANAGER
                        </div>
                    </a>

                </div>
                <div class="app-navbar navbar navbar--responsive off-canvas-responsive off-canvas-responsive--right">
                    <div class="navbar__top">
                        <a class="navbar__brand brand brand--product" href="#">
                            <div class="brand__logo server-manager-whmcs i-c-6x">
                            <img class="i-c-4x" src="../modules/addons/SUNUCUCOM/templates/assets/img/server.svg" alt="SUNUCUCOM MANAGER">
                            </div>
                            <div class="brand__text">
                                SUNUCUCOM MANAGER
                            </div>
                        </a>
                        <a class="navbar__brand brand is-right" href="https://www.sunucu.com" target="_blank">
                            <div class="brand__logo">
                                <img src="../modules/addons/SUNUCUCOM/templates/assets/img/logo.png" alt="SUNUCUCOM" width="220">
                            </div>
                        </a>
                    </div>
                </div>
                <div class="app-main">
                    <div class="app-main__body">


                        <div id="mgVueMainContainer">

                        <div class="row">
                            <div class="col-md-12 vueDatatableTable" id="labelscont">
                                <mgdatatablebodylabelscont></mgdatatablebodylabelscont>
                            </div>
                        </div>



                        <div id="vueModalContainer"></div>
                        <div class="preloader-container preloader-container--full-screen preloader-container--overlay" v-show="pagePreLoader">
                            <div class="preloader preloader--lg"></div>
                        </div>
                    </div>

                    <script type="text/javascript">
                        $(function() {
                            mgPageControler = new mgVuePageControler("mgVueMainContainer");
                            mgPageControler.vinit();
                        });
                    </script>
                    <template id="mg-datatable-templatelabelscont">
                        <div class="widget widgetActionComponent" actionid="labelscont" id="departmentSettingDataTable">
                            <div class="widget__body">
                                <div class="t-c  datatableLoader" data-table-container data-check-container>

                                    <div class="dataTables_wrapper no-footer">
                                        <div>
                                            <table class="table table--mob-collapsible dataTable no-footer dtr-column" width="100%" role="grid">
                                                <thead>
                                                    <th>
                                                        <span>ID</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['ServerName'].'</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['PackageName'].'</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['OperationSystem'].'</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['Location'].'</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['IPADDRESS'].'</span>
                                                    </th>
                                                    <th>
                                                        <span>'.$_lang['Status'].'</span>
                                                    </th>
                                                    <th style="text-align:right;">
                                                        <span>'.$_lang['CreationDate'].'</span>
                                                    </th>

                                                </thead>';

                                                foreach ($serversList->data as $key => $value) {

                                                    $response .= '<tr role="row">
                                                        <td style="font-weight:600;">'.$value->id.'</td>
                                                        <td>
                                                        	<b style="font-weight: 600;color:red">'.$value->name.'</b>
                                                        	<br>
                                                        	<i>'.$value->description.'</i>
                                                        </td>
                                                        <td>
                                                        	<b style="font-weight:600">'.$value->packageName.'</b>
                                                        </td>
                                                        <td>
                                                        	<b style="font-weight:600">'.$value->softwareName.'</b> 
                                                        	<i>'.$value->softwareDesc.'</i>
                                                        </td>
                                                        <td>
	                                                        <span class="servers_item_location_flag flag is-1x is-'.$value->locationFlag.'"></span> 
	                                                        <b style="margin-left:6px;font-weight:600">'.$value->locationName.'</b>
                                                        </td>
                                                        
                                                        <td>'.$value->ip.'</td>';
                                                        if ($value->status == "RUNNING") {
                                                        	$response .= '<td class="label-2 is-green">'.$_lang['RUNNING'].'</td>';
                                                    	}elseif ($value->status == "POWER_OFF") {
                                                        	$response .= '<td class="label-2 is-red">'.$_lang['POWER_OFF'].'</td>';
                                                    	}elseif ($value->status == "ERROR") {
                                                        	$response .= '<td class="label-2 is-red">'.$_lang['ERROR'].'</td>';
                                                    	}elseif ($value->status == "PENDING") {
                                                        	$response .= '<td class="label-2 is-orange">'.$_lang['PENDING'].' <img src="../modules/addons/SUNUCUCOM/templates/assets/img/loading.gif" height="20"></td>';
                                                    	}elseif ($value->status == "CONFIGURE") {
                                                        	$response .= '<td class="label-2 is-orange">'.$_lang['CONFIGURE'].' <img src="../modules/addons/SUNUCUCOM/templates/assets/img/loading.gif" height="20"></td>';
                                                    	}
                                                        $response .= '<td style=" text-align: right; ">'.$value->createdAt.'</td>
                                                    </tr>';

                                                }

                                            	$response .= '</table>
                                            <div class="preloader-container preloader-container--full-screen preloader-container--overlay" v-show="loading">
                                                <div class="preloader preloader--sm"></div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                	</div>
                </template>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript" src="../modules/addons/SUNUCUCOM/templates/assets/js/vue.min.js"></script>
<script type="text/javascript" src="../modules/addons/SUNUCUCOM/templates/assets/js/mgComponents.js"></script>';

echo($response);

}
